function RGRS = P3P_addRegressor_ChModel(hdata,A,M,tmpch,tmpstim)

pre = str2num(A.blkpre_sec) * 1000 / hdata.samplingperiod;
% pst = str2num(A.blkpost_sec) * 1000 / hdata.samplingperiod;
sampleN = size(hdata.stimTC, 2);
regN = size(M,1);
flag = hdata.flag(1,:,tmpch);

%----- Regressor arrangement in coutinuous data in tmpstim condition

RGRS = zeros(regN, sampleN);
indx = find(hdata.stim(:,1) == tmpstim);

for k = 1 : length(indx)
    sp = hdata.stim(indx(k),2) - pre;
    ep = sp + size(M,2)-1;
    msp = 1;
    mep = size(M,2);
    if sp < 1
        msp = -sp+1;
        sp = 1;
    end
    if ep > sampleN
        mep = mep - (ep-sampleN);
        ep = sampleN;
    end
    
    if sum(flag(sp : ep)) == 0
        %.. if Flag information = 0, set Regressor
        RGRS(:, sp:ep) = M(:, msp:mep);
    end
end
RGRS = RGRS(:, 1:sampleN); %.. edge triming
