function R = P3P_keioGLM_addRegressor_SinFluctuationNoise(hdata,N,tmpch)

flag = squeeze(hdata.flag(1,:,tmpch));
s = length(flag);
dflg = diff(flag);
indx_ep = find(dflg == 1);
% indx_sp = find(dflg == -1);
if ~isempty(indx_ep)
    indx_ep = [indx_ep s];
end

R = [];

for k = 1 : length(N)
    %.. Sine & Cosine
    tmpS = sin( (1:s)/s*2*pi*N(k) );
    tmpC = cos( (1:s)/s*2*pi*N(k) );
    if ~isempty(indx_ep)
        for i = 2 : length(indx_ep)    
            tmp = sin( (1:s)/s*2*(pi+0.5*i)*N(k) );
            tmpS(indx_ep(i-1):indx_ep(i)) = tmp(1:(indx_ep(i)-indx_ep(i-1)+1));
            tmp = cos( (1:s)/s*2*(pi+0.5*i)*N(k) );
            tmpC(indx_ep(i-1):indx_ep(i)) = tmp(1:(indx_ep(i)-indx_ep(i-1)+1));
        end
    end
    R = [R; tmpS];
    R = [R; tmpC];
end


